#include <iostream>
#include <vector>
#include <cstdio>
#include <cstring>
using namespace std;

#define TASK "droids"

typedef long long ll;
const int N = 1e5 + 10;
int n, m;
char robots[N], commands[N];
vector<int> robotsPositions, leftObstacle, rightObstacle, ans;

int main() {
    freopen(TASK".in", "r", stdin);
    freopen(TASK".out", "w", stdout);
    scanf("%d%d%s%s", &n, &m, robots, commands);
    int prevObstancle = -1;
    robots[n] = '#';
    for (int i = 0; i <= n; ++i)
        if (robots[i] == 'D') {
            robotsPositions.push_back(i);
            leftObstacle.push_back(prevObstancle);
        } else if (robots[i] == '#') {
            while (rightObstacle.size() < leftObstacle.size())
                rightObstacle.push_back(i);
            prevObstancle = i;
        }
    int minLeft = 0, maxRight = 0, pos = 0;
    for (int i = 0; i < m; ++i)
        if (commands[i] == 'L') 
            minLeft = min(minLeft, --pos);
        else
            maxRight = max(maxRight, ++pos);

    for (int i = 0; i < robotsPositions.size(); ++i) 
        if (leftObstacle[i] < robotsPositions[i] + minLeft && robotsPositions[i] + maxRight < rightObstacle[i])
            ans.push_back(robotsPositions[i] + 1);
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); ++i)
        if (i + 1 == ans.size()) printf("%d\n", ans[i]);
        else printf("%d ", ans[i]);   
    return 0;
}

